package com.yihu.wlyy.controller;


import com.yihu.wlyy.service.CAService;
import com.yihu.wlyy.service.EntranceService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * Created by zdm on 2019/5/16.
 */
@RestController
@RequestMapping(value ="/mqsdk")
@Api(value = "his信息获取解析", description = "his信息获取解析", tags = {"hospital-entrance基础服务"})
public class MqSdkController /*extends EnvelopRestEndpoint */{
    private boolean testProfiles=false;
    @Autowired
    private EntranceService entranceService;
    @Autowired
    private CAService caService;

    @GetMapping(value = "/BS15017")
    @ApiOperation(value = "固定入参：门诊余额查询")
    public String BS15017(
            @ApiParam(name = "CARD_NO", value = "卡号", required = true)
            @RequestParam(value = "CARD_NO") String CARD_NO) {
        try {
            String obj = "";
            if (!testProfiles) {
                //TODO 从银医通更新余额到his
                 //从his获取余额
                obj = entranceService.qutpatientBalance(CARD_NO);
            } else {
                obj = "{\"Msg\":{\"CARD_NO\":\"D26818411\",\"ZHYE\":\"0.00\",\"YEXZ_FLAG\":\"1\"},\"MsgCount\":\"1\",\"CurrentNum\":\"1\"}";
                //卡号不存在返回的结果为 {"code":"1","MsgInfo":{"Msg":null,"MsgCount":"1","CurrentNum":"1"}}
            }
            System.out.println("obj==" + obj);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
        return "";
    }

    @GetMapping(value = "/BS15018")
    @ApiOperation(value = "固定入参：门诊就诊卡列表")
    public String BS15018(
            @ApiParam(name = "SOCIAL_NO", value = "身份证号", required = false)
            @RequestParam(value = "SOCIAL_NO",required = false) String SOCIAL_NO,
            @ApiParam(name = "CARD_NO", value = "就诊卡号", required = false)
            @RequestParam(value = "CARD_NO",required = false) String CARD_NO) {
        try {
            String  obj="";
            if(!testProfiles){
                obj=  entranceService.BS15018(SOCIAL_NO,CARD_NO);
            }else {
                obj="[{\"PAT_NO\":\"P5616242-0  \",\"CARD_NO\":\"D40136791\",\"CARD_STAT\":\"旧卡停用\",\"OP_DATE\":\"2011-09-27 15:35:57\",\"CARD_TYPE\":\"2\",\"CARD_TYPE_NAME\":\"社保卡\",\"social_no\":\"350211198411053024\"},{\"PAT_NO\":\"P5616242-0  \",\"CARD_NO\":\"DA1872143\",\"CARD_STAT\":\"激活\",\"OP_DATE\":\"2014-07-25 08:46:40\",\"CARD_TYPE\":\"2\",\"CARD_TYPE_NAME\":\"社保卡\",\"social_no\":\"350211198411053024\"}]";
            }
            System.out.println("obj=="+obj);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
        return "";
    }

    @GetMapping(value = "/BS16017")
    @ApiOperation(value = "根据流水号或者居民id查找门诊处方信息（所有处方）")
    public String BS16017(
            @ApiParam(name = "REGISTER_SN", value = "流水号", required = false)
            @RequestParam(value = "REGISTER_SN",required = false) String REGISTER_SN,
            @ApiParam(name = "PAT_NO", value = "病人id", required = false)
            @RequestParam(value = "PAT_NO",required = false) String PAT_NO,
            @ApiParam(name = "ADM_NO", value = "住院唯一号", required = false)
            @RequestParam(value = "ADM_NO",required = false) String ADM_NO,
            @ApiParam(name = "real_order", value = "处方号", required = false)
            @RequestParam(value = "real_order",required = false) String real_order) {
        try {
            String  obj="";
            if(!testProfiles){
                obj=  entranceService.BS16017(REGISTER_SN,PAT_NO,ADM_NO,real_order);
            }else {
                obj="[{\"PAT_NO\":\"P5616242-0  \",\"CARD_NO\":\"D40136791\",\"CARD_STAT\":\"旧卡停用\",\"OP_DATE\":\"2011-09-27 15:35:57\",\"CARD_TYPE\":\"2\",\"CARD_TYPE_NAME\":\"社保卡\",\"social_no\":\"350211198411053024\"},{\"PAT_NO\":\"P5616242-0  \",\"CARD_NO\":\"DA1872143\",\"CARD_STAT\":\"激活\",\"OP_DATE\":\"2014-07-25 08:46:40\",\"CARD_TYPE\":\"2\",\"CARD_TYPE_NAME\":\"社保卡\",\"social_no\":\"350211198411053024\"}]";
            }
            System.out.println("obj=="+obj);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
        return "";
    }

    @GetMapping(value = "/BS30025")
    @ApiOperation(value = " 查询某个时间段的患者门诊就诊记录 V1.00")
    public String BS30025(@ApiParam(name = "patNo", value = "居民id")
                          @RequestParam(value = "patNo", required = false) String patNo,
                          @ApiParam(name = "admNo", value = "就诊唯一号")
                          @RequestParam(value = "admNo", required = false) String admNo,
                          @ApiParam(name = "registerSn", value = "流水号（处方号）")
                          @RequestParam(value = "registerSn", required = false) String registerSn,
                          @ApiParam(name = "startTime", value = "开始时间")
                          @RequestParam(value = "startTime", required = false) String startTime,
                          @ApiParam(name = "endTime", value = "结束时间")
                          @RequestParam(value = "endTime", required = false) String endTime) {
        try {
            String obj = "";
            if (!testProfiles) {
                obj = entranceService.BS30025(patNo,admNo,registerSn,startTime,endTime);
            } else {
                obj = "[{\"PAT_NO\":\"P5616242-0  \",\"CARD_NO\":\"D40136791\",\"CARD_STAT\":\"旧卡停用\",\"OP_DATE\":\"2011-09-27 15:35:57\",\"CARD_TYPE\":\"2\",\"CARD_TYPE_NAME\":\"社保卡\",\"social_no\":\"350211198411053024\"},{\"PAT_NO\":\"P5616242-0  \",\"CARD_NO\":\"DA1872143\",\"CARD_STAT\":\"激活\",\"OP_DATE\":\"2014-07-25 08:46:40\",\"CARD_TYPE\":\"2\",\"CARD_TYPE_NAME\":\"社保卡\",\"social_no\":\"350211198411053024\"}]";
            }
            System.out.println("obj==" + obj);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
        return "";
    }

    @GetMapping(value = "/MS30001")
    @ApiOperation(value = "医院药品字典 V1.00")
    public String MS30001(@ApiParam(name = "DRUG_CODE", value = "字典编码")
                          @RequestParam(value = "DRUG_CODE", required = false) String DRUG_CODE,
                          @ApiParam(name = "startTime", value = "就诊开始时间")
                          @RequestParam(value = "startTime", required = false) String startTime) {
        try {
            String  obj="";
            if(!testProfiles){
                obj=  entranceService.MS30001();
            }else {
                obj="[{\"PAT_NO\":\"P5616242-0  \",\"CARD_NO\":\"D40136791\",\"CARD_STAT\":\"旧卡停用\",\"OP_DATE\":\"2011-09-27 15:35:57\",\"CARD_TYPE\":\"2\",\"CARD_TYPE_NAME\":\"社保卡\",\"social_no\":\"350211198411053024\"},{\"PAT_NO\":\"P5616242-0  \",\"CARD_NO\":\"DA1872143\",\"CARD_STAT\":\"激活\",\"OP_DATE\":\"2014-07-25 08:46:40\",\"CARD_TYPE\":\"2\",\"CARD_TYPE_NAME\":\"社保卡\",\"social_no\":\"350211198411053024\"}]";
            }
            System.out.println("obj=="+obj);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
        return "";
    }


    @GetMapping(value = "/MS53001")
    @ApiOperation(value = " 医院药品字典")
    public String MS53001(@ApiParam(name = "charge_code", value = "收费码")
                          @RequestParam(value = "charge_code", required = false) String charge_code,
                          @ApiParam(name = "py_code", value = "拼音码")
                          @RequestParam(value = "py_code", required = false) String py_code,
                          @ApiParam(name = "stock_amount", value = "库存")
                          @RequestParam(value = "stock_amount", required = false) String stock_amount,
                          @ApiParam(name = "win_no", value = "库存")
                          @RequestParam(value = "win_no", required = false) String win_no,
                          @ApiParam(name = "visible_flag", value = "可用标志(0可用1不可用)")
                          @RequestParam(value = "visible_flag", required = false) String visible_flag) {
        try {
            String  obj="";
            if(!testProfiles){
                obj=  entranceService.MS53001(charge_code,py_code,stock_amount,win_no,visible_flag);
            }else {
                obj="[{\"PAT_NO\":\"P5616242-0  \",\"CARD_NO\":\"D40136791\",\"CARD_STAT\":\"旧卡停用\",\"OP_DATE\":\"2011-09-27 15:35:57\",\"CARD_TYPE\":\"2\",\"CARD_TYPE_NAME\":\"社保卡\",\"social_no\":\"350211198411053024\"},{\"PAT_NO\":\"P5616242-0  \",\"CARD_NO\":\"DA1872143\",\"CARD_STAT\":\"激活\",\"OP_DATE\":\"2014-07-25 08:46:40\",\"CARD_TYPE\":\"2\",\"CARD_TYPE_NAME\":\"社保卡\",\"social_no\":\"350211198411053024\"}]";
            }
            System.out.println("obj=="+obj);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
        return "";
    }

    @GetMapping(value = "/BS10110")
    @ApiOperation(value = "门诊给药方式")
    public String BS10110(
            @ApiParam(name = "supply_code", value = "编码")
            @RequestParam(value = "supply_code", required = false) String supply_code,
            @ApiParam(name = "py_code", value = "编码")
            @RequestParam(value = "py_code", required = false) String py_code) {
        try {
            String  obj="";
            if(!testProfiles){
                obj=  entranceService.BS10110(supply_code,py_code);
            }else {
                obj="[{\"PAT_NO\":\"P5616242-0  \",\"CARD_NO\":\"D40136791\",\"CARD_STAT\":\"旧卡停用\",\"OP_DATE\":\"2011-09-27 15:35:57\",\"CARD_TYPE\":\"2\",\"CARD_TYPE_NAME\":\"社保卡\",\"social_no\":\"350211198411053024\"},{\"PAT_NO\":\"P5616242-0  \",\"CARD_NO\":\"DA1872143\",\"CARD_STAT\":\"激活\",\"OP_DATE\":\"2014-07-25 08:46:40\",\"CARD_TYPE\":\"2\",\"CARD_TYPE_NAME\":\"社保卡\",\"social_no\":\"350211198411053024\"}]";
            }
            System.out.println("obj=="+obj);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
        return "";
    }

    @GetMapping(value = "/BS10111")
    @ApiOperation(value = "  线上挂号接口")
    public String BS10111(
            @ApiParam(name = "card_no", value = "卡号")
            @RequestParam(value = "card_no", required = false) String card_no,
            @ApiParam(name = "doctor", value = "医生工号")
            @RequestParam(value = "doctor", required = false) String doctor,
            @ApiParam(name = "dept", value = "科室编码")
            @RequestParam(value = "dept", required = false) String dept,
            @ApiParam(name = "charge_type", value = "号别")
            @RequestParam(value = "charge_type", required = false) String charge_type,
            @ApiParam(name = "win_no", value = "分部号")
            @RequestParam(value = "win_no", required = false) String win_no) {
        try {
            String  obj="";
            if(!testProfiles){
                obj=  entranceService.BS10111(card_no,doctor,dept,charge_type,win_no);
            }else {
                obj="{\"code\":\"1\",\"MsgInfo\":[{\"resquest\":{\"@RESULT\":\"-1\",\"@MSG\":\"该医生无权挂号该科室!\"}}]}";
            }
            System.out.println("obj=="+obj);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
        return "";
    }

    //多个前端使用json传参
    @GetMapping(value = "/BS10112")
    @ApiOperation(value = "线上处方接口")
    public String BS10112(
            @ApiParam(name = "card_no", value = "卡号")
            @RequestParam(value = "card_no", required = true) String card_no,
            @ApiParam(name = "doctor", value = "医生工号")
            @RequestParam(value = "doctor", required = true) String doctor,
            @ApiParam(name = "dept", value = "科室编码")
            @RequestParam(value = "dept", required = true) String dept,
            @ApiParam(name = "charge_code", value = "收费码")
            @RequestParam(value = "charge_code", required = true) String charge_code,
            @ApiParam(name = "win_no", value = "分部号")
            @RequestParam(value = "win_no", required = true) String win_no,
            @ApiParam(name = "charge_flag", value = "项目类别")
            @RequestParam(value = "charge_flag", required = true) String charge_flag,
            @ApiParam(name = "quantity", value = "数量")
            @RequestParam(value = "quantity", required = true) String quantity,
            @ApiParam(name = "serial_no", value = "挂号流水号")
            @RequestParam(value = "serial_no", required = true) String serial_no,
            @ApiParam(name = "group_no", value = "库房号")
            @RequestParam(value = "group_no", required = true) String group_no,
            @ApiParam(name = "serial", value = "药品序列号")
            @RequestParam(value = "serial", required = true) String serial,
            @ApiParam(name = "icd_code", value = "主诊断编码")
            @RequestParam(value = "icd_code", required = true) String icd_code,
            @ApiParam(name = "diag_two", value = "第二诊断")
            @RequestParam(value = "diag_two", required = false) String diag_two,
            @ApiParam(name = "diag_three", value = "第三诊断")
            @RequestParam(value = "diag_three", required = false) String diag_three,
            @ApiParam(name = "diag_four", value = "第四诊断")
            @RequestParam(value = "diag_four", required = false) String diag_four,
            @ApiParam(name = "diag_five", value = "第五诊断")
            @RequestParam(value = "diag_five", required = false) String diag_five,
            @ApiParam(name = "dosage", value = "用量")
            @RequestParam(value = "dosage", required = false) String dosage,
            @ApiParam(name = "unit", value = "用量单位")
            @RequestParam(value = "unit", required = false) String unit,
            @ApiParam(name = "usage", value = "频率")
            @RequestParam(value = "usage", required = false) String usage,
            @ApiParam(name = "supply_code", value = "用法")
            @RequestParam(value = "supply_code", required = false) String supply_code,
            @ApiParam(name = "days", value = "天数")
            @RequestParam(value = "days", required = false) String days,
            @ApiParam(name = "frequency", value = "组号")
            @RequestParam(value = "frequency", required = false) String frequency) {
        try {
            String  obj="";
            if(!testProfiles){
                obj=  entranceService.BS10112(card_no,doctor,dept,charge_code,win_no,charge_flag,quantity, serial_no,group_no,
                        serial,icd_code,diag_two,diag_three,diag_four,diag_five,dosage,unit,usage,supply_code, days,frequency);
            }else {
                obj="{\"code\":\"1\",\"MsgInfo\":[{\"resquest\":{\"@RESULT\":\"-1\",\"@MSG\":\"该医生无权挂号该科室!\"}}]}";
            }
            System.out.println("obj=="+obj);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
        return "";
    }


    @GetMapping(value = "/BS10114")
    @ApiOperation(value = "医生挂号权限查询接口 ")
    public String BS10114(
            @ApiParam(name = "doctor_code", value = "医生工号")
            @RequestParam(value = "doctor_code", required = false) String doctor_code,
            @ApiParam(name = "dept", value = "科室编码")
            @RequestParam(value = "dept", required = false) String dept,
            @ApiParam(name = "charge_type", value = "号别编码")
            @RequestParam(value = "charge_type", required = false) String charge_type,
            @ApiParam(name = "win_no", value = "分部号")
            @RequestParam(value = "win_no", required = false) String win_no) {
        try {
            String  obj="";
            if(!testProfiles){
                obj=  entranceService.BS10114(doctor_code,dept,charge_type,win_no);
            }else {
                obj="{\"code\":\"1\",\"MsgInfo\":[{\"resquest\":{\"@RESULT\":\"-1\",\"@MSG\":\"该医生无权挂号该科室!\"}}]}";
            }
            System.out.println("obj=="+obj);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
        return "";
    }

    @GetMapping(value = "/MS02001")
    @ApiOperation(value = "科室字典  ")
    public String MS02001() {
        try {
            String  obj="";
            if(!testProfiles){
                obj=  entranceService.MS02001();
            }else {
                obj="{\"code\":\"1\",\"MsgInfo\":[{\"resquest\":{\"@RESULT\":\"-1\",\"@MSG\":\"该医生无权挂号该科室!\"}}]}";
            }
            //TODO 待解析 存储入库
            System.out.println("obj=="+obj);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
        return "";
    }

    @GetMapping(value = "/MS02013")
    @ApiOperation(value = "号别字典接口   ")
    public String MS02013() {
        try {
            String  obj="";
            if(!testProfiles){
                obj=  entranceService.MS02013();
            }else {
                obj="{\"code\":\"1\",\"MsgInfo\":[{\"resquest\":{\"@RESULT\":\"-1\",\"@MSG\":\"该医生无权挂号该科室!\"}}]}";
            }
            System.out.println("obj=="+obj);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
        return "";
    }

    @GetMapping(value = "/MS30012")
    @ApiOperation(value = "医院频次")
    public String MS30012() {
        try {
            String  obj="";
            if(!testProfiles){
                obj=  entranceService.MS30012();
            }else {
                obj="{\"code\":\"1\",\"MsgInfo\":[{\"resquest\":{\"@RESULT\":\"-1\",\"@MSG\":\"该医生无权挂号该科室!\"}}]}";
            }
            System.out.println("obj=="+obj);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
        return "";
    }


    @GetMapping(value = "/MS25001")
    @ApiOperation(value = "Icd10诊断编码")
    public String MS25001( @ApiParam(name = "py_code", value = "拼音码")
                            @RequestParam(value = "py_code", required = false) String py_code) {
        try {
            String  obj="";
            if(!testProfiles){
                obj=  entranceService.MS25001(py_code);
            }else {
                obj="{\"code\":\"1\",\"MsgInfo\":[{\"resquest\":{\"@RESULT\":\"-1\",\"@MSG\":\"该医生无权挂号该科室!\"}}]}";
            }
            System.out.println("obj=="+obj);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
        return "";
    }


    @GetMapping(value = "/MS25002")
    @ApiOperation(value = " 检查检验字典接口 ")
    public String MS25002( @ApiParam(name = "py_code", value = "拼音码")
                           @RequestParam(value = "py_code", required = false) String py_code,
                           @ApiParam(name = "win_no", value = "库存")
                           @RequestParam(value = "win_no", required = false) String win_no) {
        try {
            String  obj="";
            if(!testProfiles){
                obj=  entranceService.MS25002(py_code,win_no);
            }else {
                obj="{\"code\":\"1\",\"MsgInfo\":[{\"resquest\":{\"@RESULT\":\"-1\",\"@MSG\":\"该医生无权挂号该科室!\"}}]}";
            }
            System.out.println("obj=="+obj);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
        return "";
    }
/*
    @GetMapping(value = "/testCa")
    @ApiOperation(value = " webService测试 ")
    public String testCa(String strSignData,String strCertData,String strOriginalData,String srcBusinessStreamNO) {
        try {
            String  obj="";
            caService.verifySignOnMultiServer( strSignData, strCertData, strOriginalData, srcBusinessStreamNO);
            System.out.println("obj=="+obj);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
        return "";
    }*/

    @GetMapping(value = "/yytDown")
    @ApiOperation(value = " 银医通下载 ")
    public String yytDown(
            @ApiParam(name = "cardNo", value = "卡号", required = true)
            @RequestParam(value = "cardNo") String cardNo) {
        try {
            String  obj="";
           obj= caService.callYYTServerService(cardNo);
//            System.out.println("obj=="+obj);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
        return "";
    }

  /*  @GetMapping(value = "/yytDown1")
    @ApiOperation(value = " 银医通下载 ")
    public String yytDown1() {
        try {
            String  obj="";
            obj= caService.callYYTServerService1();
            System.out.println("obj=="+obj);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
        return "";
    }*/

    @GetMapping(value = "/guahao")
    @ApiOperation(value = " 查询某个时间段的患者门诊就诊记录 V1.00")
    public String guahao(@ApiParam(name = "patNo", value = "居民id")
                          @RequestParam(value = "patNo",required = false) String patNo,
                          @ApiParam(name = "dept", value = "挂号科室")
                          @RequestParam(value = "dept",required = false) String dept,
                          @ApiParam(name = "doctor", value = "就诊医生")
                          @RequestParam(value = "doctor",required = false) String doctor) {
        try {
            String obj = "";
            if (!testProfiles) {
                obj = entranceService.guahao(patNo,dept,doctor);
            } else {
                obj = "[{\"PAT_NO\":\"P5616242-0  \",\"CARD_NO\":\"D40136791\",\"CARD_STAT\":\"旧卡停用\",\"OP_DATE\":\"2011-09-27 15:35:57\",\"CARD_TYPE\":\"2\",\"CARD_TYPE_NAME\":\"社保卡\",\"social_no\":\"350211198411053024\"},{\"PAT_NO\":\"P5616242-0  \",\"CARD_NO\":\"DA1872143\",\"CARD_STAT\":\"激活\",\"OP_DATE\":\"2014-07-25 08:46:40\",\"CARD_TYPE\":\"2\",\"CARD_TYPE_NAME\":\"社保卡\",\"social_no\":\"350211198411053024\"}]";
            }
            System.out.println("obj==" + obj);
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
        return "";
    }

}
