/*
package com.yihu.wlyy.service;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.yihu.wlyy.service.common.SystemConfig;
import com.yihu.wlyy.service.common.http.HttpApiException;
import com.yihu.wlyy.service.common.model.Result;
import com.yihu.wlyy.service.common.util.StringUtil;
import com.yihu.wlyy.service.dao.HospitalMappingDao;
import com.yihu.wlyy.service.dao.log.ZyPushLogDao;
import com.yihu.wlyy.service.dao.log.ZyPushLogDetailDao;
import com.yihu.wlyy.service.entity.HospitalMapping;
import com.yihu.wlyy.service.entity.log.ZyPushLog;
import com.yihu.wlyy.service.entity.log.ZyPushLogDetail;
import com.zoe.phip.ssp.sdk.ApiException;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.*;

*/
/**
 * 智业接口--基本方法
 * Created by yeshijie on 2017/7/17.
 *//*

@Service
public class ZysoftBaseService {

    private org.slf4j.Logger logger= LoggerFactory.getLogger(ZysoftBaseService.class);

    @Autowired
    private LogService logService;

    @Autowired
    private ObjectMapper objectMapper;
    @Autowired
    private HospitalMappingDao hospitalMappingDao;
    @Autowired
    private ZyPushLogDao zyPushLogDao;
    @Autowired
    private ZyPushLogDetailDao zyPushLogDetailDao;
    //默认重复次数
    private int retryTimes = 3;

    @Value("${zysoftApi.internet}")
    private String internet;
    @Value("${zysoftApi.base}")
    private String base;
    @Value("${zysoftApi.imm}")
    private String imm;
    @Value("${zyapi.openCrypto}")
    private Boolean openCrypto;

    public String getCode() {
        return UUID.randomUUID().toString().replaceAll("-", "");
    }

    */
/**
     * 保存智业推送日志
     * @param request
     * @param api
     * @param content
     * @param error
     * @param method
     * @param status
     * @param type
     *//*

    public Result addZyPushLog(String request, String api, String content, String error, String method, String status, String type,String errMsg){
        Result re = null;
        if(errMsg==null){
            re = Result.success(content);
        }else {
            re = Result.error(-1,errMsg);
        }
        ZyPushLog log = new ZyPushLog();
        log.setCreateTime(new Date());
        log.setApi(api);
        log.setContent(content);
//        log.setError(error);
        log.setMethod(method);
//        log.setRequest(request);
//        log.setResponse(JSONObject.toJSONString(re,SerializerFeature.WriteMapNullValue));
        log.setRetryTimes(0);
        log.setStatus(status);
        log.setType(type);
        zyPushLogDao.save(log);

        //明细表
        ZyPushLogDetail detail = new ZyPushLogDetail();
        detail.setCode(log.getId());
        detail.setError(error);
        detail.setCreateTime(new Date());
        detail.setResponse(JSONObject.toJSONString(re,SerializerFeature.WriteMapNullValue));
        detail.setRequest(request);
        zyPushLogDetailDao.save(detail);

        return re;
    }

    */
/**
     * 获取基础路径
     * @param apiType
     * @return
     *//*

    private String getBaseApi(Integer apiType){
        String baseApi = "";
        switch (apiType){
            case 1:
                baseApi = base;
                break;
            case 2:
                baseApi = internet;
                break;
            default:
                baseApi = base;
                break;
        }
        return baseApi;
    }


    */
/**
     * 基卫二次封装Get接口
     *//*

    public String getSecond(String api, String content, Map<String,String> params, Map<String,String> headers, boolean needRetry,Integer apiType) throws Exception
    {
        String re = "";
        headers.put("INTERFACE",api);

        Map<String,String> paramsList = new HashMap<>();

        String msgBody = JSONObject.toJSONString(params, SerializerFeature.WriteMapNullValue);
        String msgHeader = JSONObject.toJSONString(headers, SerializerFeature.WriteMapNullValue);
        paramsList.put("msgHeader",msgHeader);
        paramsList.put("msgBody",msgBody);

        logger.info("msgHeader:"+msgHeader+"\r\n");
        logger.info("msgBody:"+msgBody+"\r\n");

        //新增日志
        String method = "GET";
        Boolean isSuccess = true;
        String error = "";

        String baseApi = getBaseApi(apiType);

        int times = 0;
        try {
            re = ZysoftApi.getSingleton().get(baseApi, paramsList, null,openCrypto);
            if(needRetry)
            {

                while(retryTimes>0 && re.contains("接口调用传入的参数[msgHeader]格式不正确"))    //基卫bug预防，重调接口
                {
                    re = ZysoftApi.getSingleton().post(baseApi, paramsList, null,openCrypto);
                    retryTimes --;
                    times++;
                }
            }

            Map<String,String> map = objectMapper.readValue(re,Map.class);
            String code = map.get("CODE");
            String message = map.get("MESSAGE");

            if(!code.equals("1"))
            {
                throw new HttpApiException(Integer.valueOf(code),message);
            }
            //保存http日志
//            logService.saveHttpLog(isSuccess,api,content,method,msgHeader,msgBody,re,error);
            logService.saveZyPushLog(api,content,null,"POST",msgHeader+","+msgBody,re,"1","2");
        }
        catch (Exception ex)
        {
            StringWriter sw = new StringWriter();
            PrintWriter pw = new PrintWriter(sw);
            ex.printStackTrace(pw);

            error = sw.toString();
            isSuccess = false;
            //保存http日志
//            logService.saveHttpLog(isSuccess,api,content,method,msgHeader,msgBody,re,error);
            logService.saveZyPushLog(api,content,null,"POST",msgHeader+","+msgBody,re,"0","2");

            if(ex instanceof ApiException)
            {
                ApiException apiEx = (ApiException) ex;
                throw new HttpApiException(apiEx.errorCode(),ex.getMessage());
            }
            else{
                throw new HttpApiException(-1,ex.getMessage());
            }
        }

        return re;
    }

    */
/**
     * 基卫二次封装Post接口
     *//*

    public String postSecond(String api,String content, Map<String,String> params,JSONObject jsonParams, Map<String,String> headers,boolean needRetry,Integer apiType,String type) throws Exception
    {
        String re = "";
        headers.put("INTERFACE",api);

        Map<String,String> paramsList = new HashMap<>();
        String msgBody = params==null?JSONObject.toJSONString(jsonParams, SerializerFeature.WriteMapNullValue):JSONObject.toJSONString(params, SerializerFeature.WriteMapNullValue);
        String msgHeader = JSONObject.toJSONString(headers, SerializerFeature.WriteMapNullValue);
        paramsList.put("msgHeader",msgHeader);
        paramsList.put("msgBody",msgBody);

        logger.info("msgHeader:"+msgHeader+"\r\n");
        logger.info("msgBody:"+msgBody+"\r\n");

        //新增日志
        String method = "POST";
        Boolean isSuccess = true;
        String error = "";

        String baseApi = getBaseApi(apiType);

        int times = 0;
        try {
            re = ZysoftApi.getSingleton().post(baseApi, paramsList, null,openCrypto);
            if(needRetry)
            {
                int maxTimes = retryTimes;
                while(maxTimes>0 && re.contains("接口调用传入的参数[msgHeader]格式不正确"))    //基卫bug预防，重调接口
                {
                    re = ZysoftApi.getSingleton().post(baseApi, paramsList, null,openCrypto);
                    maxTimes --;
                    times++;
                }
            }

            Map<String,String> map = objectMapper.readValue(re,Map.class);
            String code = map.get("CODE");

            if(!code.equals("1"))
            {
                throw new HttpApiException(Integer.valueOf(code),map.get("MESSAGE"));
            }

//            com.alibaba.fastjson.JSONObject j = com.alibaba.fastjson.JSONObject.parseObject(re);
            //保存http日志
//            logService.saveHttpLog(isSuccess,api,content,method,msgHeader,msgBody,re,error);
            logService.saveZyPushLog(api,content,null,"POST",msgHeader+","+msgBody,re,"1",type);
        }
        catch (Exception ex)
        {
            StringWriter sw = new StringWriter();
            PrintWriter pw = new PrintWriter(sw);
            ex.printStackTrace(pw);
            error = sw.toString();

            //保存http日志
//            logService.saveHttpLog(isSuccess,api,content,method,msgHeader,msgBody,re,error);
            logService.saveZyPushLog(api,content,error,"POST",msgHeader+","+msgBody,re,"0",type);

            if(ex instanceof ApiException)
            {
                ApiException apiEx = (ApiException) ex;
                throw new HttpApiException(apiEx.errorCode(),ex.getMessage());
            }
            else{
                throw new HttpApiException(-1,ex.getMessage());
            }
        }

        return re;
    }

    */
/**
     * 获取机构映射
     *//*

    public String[] getHospitalMapping(String hospital) throws Exception
    {
        if(StringUtil.isEmpty(hospital)) //使用默认医院
        {
            String mappingCode = SystemConfig.getInstance().getJwHospital();
            String licence = SystemConfig.getInstance().getJwLicence();
            return new String[]{mappingCode,licence};
        }
        else {
            HospitalMapping hm = hospitalMappingDao.getMappingCode(hospital, "1");  //转换成基卫机构代码
            String licence = "";
            if (hm != null && !StringUtil.isEmpty(hm.getMappingCode()) && !StringUtil.isEmpty(hm.getLicence())) {
                hospital = hm.getMappingCode();
                licence = hm.getLicence();
            } else {
                throw new Exception("机构【" + hospital + "】映射配置未完善！");
            }
            return new String[]{hospital, licence};
        }
    }


    */
/*************************** 格式转换 *******************************************************//*

    */
/**
     * 获取单对象
     *//*

    public Map<String,String> getJwOne(String response) throws Exception
    {
        Map<String,String> re = new HashMap<>();
        Map<String,Object> map = objectMapper.readValue(response,Map.class);
        String code = String.valueOf(map.get("CODE"));
        if(code.equals("1")) {
            List<Map<String, String>> list = (List<Map<String, String>>) map.get("DATA");
            if (list != null && list.size() > 0) {
                re = list.get(0);
            }
        }
        else{
            re.put("MESSAGE",String.valueOf(map.get("MESSAGE")));
        }

        return re;
    }

    */
/**
     * 获取单对象列表
     **//*

    public List<Map<String,String>> getJwList(String response) throws Exception
    {
        Map<String,Object> map = objectMapper.readValue(response,Map.class);
        List<Map<String,String>> list = (List<Map<String,String>>)map.get("DATA");

        return list;
    }
}
*/
