package com.yihu.wlyy.util;
import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.xml.namespace.QName;
import java.util.Map;


/**
 * Created by hzp on 2017/7/31.
 * webservice调用服务
 **/
public class WebserviceUtil {

    private static Logger logger = LoggerFactory.getLogger(WebserviceUtil.class);

   /*  * webservice 调用接口*/

    public static String post(String urlString,String namespace,String api, Map<String,String> params) throws Exception {
        try {
            Service service = new Service();
            // 通过service创建call对象
            Call call = (Call) service.createCall();
            // 设置service所在URL
            call.setTargetEndpointAddress(new java.net.URL(urlString));
            call.setOperationName(new QName(namespace, api));
            call.setUseSOAPAction(true);
            Object[] objs = null;
            if (params != null && params.size() > 0) {
                objs = new Object[params.size()];
                int i = 0;
                for (String key : params.keySet()) {
                    //接口的参数
                    call.addParameter(new QName(key), org.apache.axis.encoding.XMLType.XSD_STRING, javax.xml.rpc.ParameterMode.IN);
                    objs[i] = params.get(key);
                    i++;
                }
            }
            //设置返回类型
            call.setReturnType(org.apache.axis.encoding.XMLType.XSD_STRING);
            String ret = (String) call.invoke(objs);
            logger.info("=======>请求结果.toString()：" + ret.toString());
            return ret.toString();

        } catch (Exception e) {
            logger.info("=======>CA请求报错：" + e.getMessage());
            e.printStackTrace();
            throw e;
        }
    }



  /**
     * 通过soap方式访问接口
     *
     * @param paramVO
     * @throws Exception
     */
    /*public static String callMethod(WebServiceParamVO  paramVO) throws Exception {
        SOAPMappingRegistry smr = new SOAPMappingRegistry();
        StringDeserializer sd = new StringDeserializer();
        smr.mapTypes(Constants.NS_URI_XMLNS, new org.apache.soap.util.xml.QName("", "return"), null,
                null, sd);
        // 创建传输路径和参数
        SOAPHTTPConnection st = new SOAPHTTPConnection();
        // 创建调用
        Call call = new Call();
        call.setSOAPTransport(st);
        call.setSOAPMappingRegistry(smr);
        call.setTargetObjectURI(paramVO.getTargetObjectURI());
        call.setMethodName(paramVO.getMethodName());
        call.setEncodingStyleURI(Constants.NS_URI_SOAP_ENC);
        Vector<Parameter> params = getParameter(paramVO);
        call.setParams(params);
        URL url = new URL(paramVO.getWsdlUrl());
        Response resp = call.invoke(url, paramVO.getSoapAction());
        if (resp == null) {
            return null;
        }
        if (resp.generatedFault()) {
            Fault fault = resp.getFault();
            throw new Exception(fault.getFaultString());
        }
        Parameter ret = resp.getReturnValue();
        Object value = ret.getValue();
        return (String) value;
    }

    private static Vector<Parameter> getParameter(WebServiceParamVO paramVO) {
        Vector<Parameter> params = new Vector<Parameter>();
        params.addElement(new Parameter("ServerInfo",String.class, paramVO.getServerInfo(), null));
        params.addElement(new Parameter("RegMsg",String.class, paramVO.getRegMsg(), null));
        return params;
    }*/


}
